凌云实验室推出的ARM Linux物联网网关开发板IGKBoard(IoT Gateway Kit Board)项目源码
guowenxue
2021-12-18 8785a11c555a8dc88fce52e77c8fdf27574f7f52
bsp/images/build.sh
@@ -7,7 +7,7 @@
# +-------------------------------+-----------------------+---------------------------------+
# |         Start  Address        |         Size          |           Usage                 |
# +-------------------------------+-----------------------+---------------------------------+
# |             0x0               |   32 sectors(16K)     |  Reserved for partition table   |
# |             0x0               |     2 sectors(1K)     |  Reserved for partition table   |
# +-------------------------------+-----------------------+---------------------------------+
# |      2 sector(1K, 0x400)      |  20414 sectors(9M+)   |     i.MX6ULL  u-boot image      |
# +-------------------------------+-----------------------+---------------------------------+
@@ -18,11 +18,13 @@
#
PRJ_PATH=`pwd`
IMAGE_PATH=${PRJ_PATH}/bin/
PRJ_NAME=`basename ${PRJ_PATH}`
BOARD=imx6ull
IMAGE_PATH=${PRJ_PATH}/boot/
# rootfs should be buildroot or stretch/buster/bullseye for debian system
BOARD=igkboard
# rootfs should be buildroot/yocto or bullseye for debian system
ROOTFS=buildroot
# linux kernel tarball path and branch
@@ -37,20 +39,21 @@
    IMAGE_SIZE=2048
fi
# 1 sector - for i.MX6 or i.MX7
UBOOT_OFSET=1
#i.MX6/i.MX7 read uboot from mmc start on sector #2
UBOOT_OFSET=2
MMC_SECSIZE=512
# BootRom(U-boot) Size 10MB:  20480 Sectors * 512B
# U-boot space Size 10MB
UBOOT_SIZE=10
# vfat boot partition size
# vfat boot partition 100MB
BOOT_SIZE=100
IMG_UBOOT=${IMAGE_PATH}/u-boot-imx6ull-emmc.imx
IMG_KERNEL=${IMAGE_PATH}/Image
IMG_DTB=${IMAGE_PATH}/imx6ull-emmc.dtb
ROOTFS_TAR=${TAR_PATH}/rootfs_${ROOTFS}.tar.bz2
IMG_UBOOT=${PRJ_PATH}/u-boot-${BOARD}-emmc.imx
IMG_KERNEL=${IMAGE_PATH}/zImage
IMG_DTB=${IMAGE_PATH}/${BOARD}-emmc.dtb
ROOTFS_TAR=${PRJ_PATH}/../rootfs/rootfs_${ROOTFS}.tar.bz2
MNT_POINT=./mnt
LOOP_DEV=`losetup  -f | cut -d/ -f3`
@@ -58,30 +61,29 @@
set -u
set -e
if [ `id -u` != 0 ] ; then
    echo "ERROR: This shell script must run as root"
    exit 0;
fi
trap 'exit_handler' EXIT
function exit_handler()
{
    echo "Shell script exit now, do some clean work"
    echo ""
    set +e
    mountpoint $MNT_POINT > /dev/null 2>&1
    if [ $? == 0 ] ; then
        echo "umount ${MNT_POINT}"
        umount ${MNT_POINT}
    fi
    rm -rf ${MNT_POINT}
    if [ -L /dev/mapper/${LOOP_DEV}p1 ] ; then
        echo "kpartx -dv /dev/${LOOP_DEV}"
        kpartx -dv /dev/${LOOP_DEV}
    fi
    losetup -a | grep "${LOOP_DEV}" > /dev/null 2>&1
    if [ $? == 0 ]  ; then
        echo "losetup -d /dev/${LOOP_DEV}"
        losetup -d /dev/${LOOP_DEV}
    fi
}
@@ -101,16 +103,13 @@
function generate_image()
{
    # system image block count by block=512k
    BLOCK_CNT=`expr 2 \* ${IMAGE_SIZE}`
    # FAT32 boot partition start/end address in MB
    BOOT_START=${UBOOT_SIZE}
    BOOT_END=`expr ${BOOT_START} + ${BOOT_SIZE}`
    msg_banner " <${STAGE}> Generate system image "
    dd if=/dev/zero of=${IMAGE_NAME} bs=512k count=${BLOCK_CNT}  && sync
    dd if=/dev/zero of=${IMAGE_NAME} bs=1024k count=${IMAGE_SIZE}  && sync
    chmod a+x ${IMAGE_NAME}
    msg_banner " <${STAGE}> Partition system image "
@@ -139,7 +138,7 @@
function install_sysimg()
{
    msg_banner " <${STAGE}> Install u-boot image"
    sudo dd if=${IMG_UBOOT} of=${IMAGE_NAME} bs=1k seek=${UBOOT_OFSET} conv=notrunc,sync
    sudo dd if=${IMG_UBOOT} of=${IMAGE_NAME} bs=${MMC_SECSIZE} seek=${UBOOT_OFSET} conv=notrunc,sync
    msg_banner " <${STAGE}> Install linux kernel image"
@@ -166,19 +165,91 @@
    mount -t ext4 /dev/mapper/${LOOP_DEV}p2 ${MNT_POINT}
    tar -xjf ${ROOTFS_TAR} -C ${MNT_POINT} && sync
    chown -R root.root ${MNT_POINT} && sync
    umount ${MNT_POINT}
}
mkdir -p ${MNT_POINT}
function do_distclean()
{
    printf "\n\n -- do distclean in `basename ${PRJ_PATH}` --\n\n"
generate_image
    rm -f  *${BOARD}*
    rm -rf boot/*Image*
    rm -rf boot/overlays/
    rm -rf boot/*${BOARD}*
    exit 0;
}
format_partition
function do_image()
{
    mkdir -p ${MNT_POINT}
install_sysimg
    generate_image
install_rootfs
    format_partition
rm -rf ${MNT_POINT}
    install_sysimg
    install_rootfs
    msg_banner " bzip2 compress system image "
    rm -f ${IMAGE_NAME}*.bz2
    bzip2 ${IMAGE_NAME}
    rm -rf ${MNT_POINT}
    printf "\n\n -- generate system image done --\n\n"
}
function do_root()
{
    echo ""
    if [[ $1 == "yes" ]] && [ `id -u` != 0 ] ; then
        echo "ERROR: This action must run as root!"
        echo ""
        exit;
    elif [[ $1 != "yes" ]] && [ `id -u` == 0 ] ; then
        echo "ERROR: This action cannot run as root!"
        echo ""
        exit;
    fi
}
function do_usage()
{
    echo ""
    echo "Usage:"
    echo "   $0 [-b] [-c] [-h]"
    echo "       -b: download and build $PRJ_NAME"
    echo "       -c: clean all the source code"
    echo "       -h: show this help message"
    echo ""
    echo " WARNNING: This shell script must run as sudo"
    echo ""
    exit;
}
trap 'exit_handler' EXIT
while getopts "bch" OPTNAME
do
    case "${OPTNAME}" in
        "b")
            break;
            ;;
        "c")
            do_root "yes"
            do_distclean
            ;;
        "*")
            do_usage
            ;;
    esac
done
do_root "yes"
do_image
exit;